function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { return function () { var Super = _getPrototypeOf(Derived), result; if (_isNativeReflectConstruct()) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

import React from 'react';
import PropTypes from 'prop-types';
import { LocaleReceiver } from 'mkui-fd';
import { EnhancedTreeSelect } from 'mkui-ext';
import defaultLocale from '../locale-provider/default';

var noop = function noop() {};

var CostTrackingSelect = /*#__PURE__*/function (_React$Component) {
  _inherits(CostTrackingSelect, _React$Component);

  var _super = _createSuper(CostTrackingSelect);

  /** *******************static************************** */

  /** *******************life cycle************************** */

  /** *******************handle************************** */
  function CostTrackingSelect(props) {
    var _this;

    _classCallCheck(this, CostTrackingSelect);

    _this = _super.call(this, props);

    _defineProperty(_assertThisInitialized(_this), "apiAdapter", function () {
      var options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
      var _this$props = _this.props,
          api = _this$props.api,
          treeApi = _this$props.treeApi,
          params = _this$props.params,
          code = _this$props.code;
      var inited = _this.state.inited;
      var keyword = options.keywords;
      return new Promise(function (resolve) {
        var apiParams = _objectSpread({}, params, {
          costTrackingCode: code
        });

        if (inited) {
          api(_objectSpread({}, apiParams, {
            categoryCode: options.code,
            keyword: keyword,
            cipherKeyword: keyword
          })).then(function (data) {
            resolve(data.list);
          });
        } else {
          treeApi(code).then(function (res) {
            var treeData = res.children || [];
            api(_objectSpread({}, apiParams, {
              categoryCode: res.code
            })).then(function (data) {
              _this.setState({
                inited: true,
                rootName: res.name
              });

              resolve(treeData.concat(data.list));
            });
          });
        }
      });
    });

    _defineProperty(_assertThisInitialized(_this), "searchResultRender", function (item) {
      return item.fullName.join(' / ');
    });

    _defineProperty(_assertThisInitialized(_this), "renderContent", function (contextLocale) {
      var _this$props2 = _this.props,
          value = _this$props2.value,
          onChange = _this$props2.onChange,
          disabled = _this$props2.disabled,
          placement = _this$props2.placement,
          theme = _this$props2.theme;
      var rootName = _this.state.rootName;
      var placeholder = _this.props.placeholder;

      if (disabled && !value) {
        placeholder = contextLocale.no;
      }

      return /*#__PURE__*/React.createElement(EnhancedTreeSelect, {
        theme: theme,
        api: _this.apiAdapter,
        lazyLoad: true,
        value: value,
        disabled: disabled,
        labelInValue: true,
        allowClear: true,
        placeholder: placeholder,
        searchPlaceholder: "\u8BF7\u8F93\u5165\u540D\u79F0\u3001\u7F16\u7801\u641C\u7D22...",
        onChange: onChange,
        placement: placement,
        showSearch: true,
        rootName: rootName,
        searchResultRender: _this.searchResultRender
      });
    });

    _this.state = {
      inited: false,
      rootName: ''
    };
    return _this;
  }
  /** *******************inner method************************** */


  _createClass(CostTrackingSelect, [{
    key: "render",
    value: function render() {
      return /*#__PURE__*/React.createElement(LocaleReceiver, {
        componentName: "TaxRateGroup",
        defaultLocale: defaultLocale.CostTrackingSelect
      }, this.renderContent);
    }
  }]);

  return CostTrackingSelect;
}(React.Component);

_defineProperty(CostTrackingSelect, "propTypes", {
  api: PropTypes.func,
  code: PropTypes.string,
  treeApi: PropTypes.func,
  onChange: PropTypes.func,
  value: PropTypes.object,
  disabled: PropTypes.bool,
  params: PropTypes.object,
  placeholder: PropTypes.string,
  placement: PropTypes.string,
  theme: PropTypes.string
});

_defineProperty(CostTrackingSelect, "defaultProps", {
  api: noop,
  treeApi: noop,
  onChange: noop,
  value: null,
  disabled: false,
  params: {}
});

export default CostTrackingSelect;
//# sourceMappingURL=CostTrackingSelect.js.map
