function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { return function () { var Super = _getPrototypeOf(Derived), result; if (_isNativeReflectConstruct()) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

import React from 'react';
import PropTypes from 'prop-types';
import classNames from 'classnames';
import Basic from '../_layout';
import generator from '../_layout/util';
import AutoHeight from './AutoHeight';

var Layout = /*#__PURE__*/function (_React$PureComponent) {
  _inherits(Layout, _React$PureComponent);

  var _super = _createSuper(Layout);

  function Layout() {
    _classCallCheck(this, Layout);

    return _super.apply(this, arguments);
  }

  _createClass(Layout, [{
    key: "render",

    /** *******************static************************** */
    value: function render() {
      var _this$props = this.props,
          prefixCls = _this$props.prefixCls,
          hasHead = _this$props.hasHead,
          children = _this$props.children;
      var wrapperCls = classNames("".concat(prefixCls), _defineProperty({}, "".concat(prefixCls, "-has-head"), hasHead === true));
      return /*#__PURE__*/React.createElement("div", {
        className: wrapperCls
      }, children);
    }
  }]);

  return Layout;
}(React.PureComponent);

_defineProperty(Layout, "propTypes", {
  prefixCls: PropTypes.string,
  hasHead: PropTypes.bool
});

_defineProperty(Layout, "defaultProps", {
  prefixCls: 'mkui-layout-list',
  hasHead: false
});

var Header = generator({
  prefixCls: 'mkui-layout-list-header'
})(Basic);
var Content = generator({
  prefixCls: 'mkui-layout-list-content'
})(Basic);
var ToolBar = generator({
  prefixCls: 'mkui-layout-list-content-toolbar'
})(Basic);
var Filter = generator({
  prefixCls: 'mkui-layout-list-content-filter'
})(Basic);
var Table = generator({
  prefixCls: 'mkui-layout-list-content-table'
})(Basic);
Content.ListToolBar = ToolBar;
Content.ListFilterWrapper = Filter;
Content.ListTableWrapper = Table;
Layout.ListHeader = Header;
Layout.ListContent = Content;
Layout.AutoHeight = AutoHeight;
export default Layout;
//# sourceMappingURL=LayoutList.js.map
