function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _unsupportedIterableToArray(arr) || _nonIterableSpread(); }

function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(n); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _iterableToArray(iter) { if (typeof Symbol !== "undefined" && Symbol.iterator in Object(iter)) return Array.from(iter); }

function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) return _arrayLikeToArray(arr); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { return function () { var Super = _getPrototypeOf(Derived), result; if (_isNativeReflectConstruct()) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

import React from 'react';
import PropTypes from 'prop-types';
import { EnhancedTreeSelect } from 'mkui-ext';

var noop = function noop() {};

var OptionSelect = /*#__PURE__*/function (_React$Component) {
  _inherits(OptionSelect, _React$Component);

  var _super = _createSuper(OptionSelect);

  /** *******************static************************** */

  /** *******************life cycle************************** */
  function OptionSelect(props) {
    var _this;

    _classCallCheck(this, OptionSelect);

    _this = _super.call(this, props);

    _defineProperty(_assertThisInitialized(_this), "apiAdapter", function () {
      var options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
      var api = _this.props.api;

      var params = _objectSpread({}, options, {
        categoryCode: options.code
      });

      return new Promise(function (resolve) {
        api(params).then(function (res) {
          var data = _this.formatData(res || {});

          if (!options.code) {
            _this.setState({
              rootName: res.name
            });

            if (!res.categories || !res.categories.length) {
              _this.setState({
                showBreadcrumb: false
              });
            }
          }

          resolve(data);
        });
      });
    });

    _defineProperty(_assertThisInitialized(_this), "formatData", function (data) {
      var categories = data.categories || [];
      var items = data.items || [];
      categories.map(function (category) {
        category.leaf = false;
        return category;
      });
      items.map(function (item) {
        item.leaf = true;
        return item;
      });
      return [].concat(_toConsumableArray(categories), _toConsumableArray(items));
    });

    _this.state = {
      rootName: '',
      showBreadcrumb: true
    };
    return _this;
  }
  /** *******************handle************************** */

  /** *******************inner method************************** */


  _createClass(OptionSelect, [{
    key: "render",

    /** *******************render************************** */
    value: function render() {
      var _this$props = this.props,
          value = _this$props.value,
          onChange = _this$props.onChange,
          disabled = _this$props.disabled,
          multiple = _this$props.multiple,
          placeholder = _this$props.placeholder,
          other = _objectWithoutProperties(_this$props, ["value", "onChange", "disabled", "multiple", "placeholder"]);

      var _this$state = this.state,
          rootName = _this$state.rootName,
          showBreadcrumb = _this$state.showBreadcrumb;
      return /*#__PURE__*/React.createElement(EnhancedTreeSelect, _extends({}, other, {
        api: this.apiAdapter,
        value: value,
        disabled: disabled,
        placeholder: placeholder,
        onChange: onChange,
        rootName: rootName,
        searchResultRender: this.searchResultRender,
        multiple: multiple,
        showBreadcrumb: showBreadcrumb
      }));
    }
  }]);

  return OptionSelect;
}(React.Component);

_defineProperty(OptionSelect, "propTypes", {
  api: PropTypes.func,
  onChange: PropTypes.func,
  value: PropTypes.object,
  disabled: PropTypes.bool
});

_defineProperty(OptionSelect, "defaultProps", {
  api: noop,
  onChange: noop,
  value: null,
  disabled: false,
  placeholder: '请选择'
});

export default OptionSelect;
//# sourceMappingURL=OptionSelect.js.map
