"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.defaultPropTypes = exports.propTypes = void 0;

var _propTypes = _interopRequireDefault(require("prop-types"));

var _noop = _interopRequireDefault(require("../_util/noop"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

/**
 * Created by pzf on 18/9/1.
 *
 */
var propTypes = {
  prefixCls: _propTypes["default"].string,
  readonly: _propTypes["default"].bool,
  multiple: _propTypes["default"].bool,
  onChange: _propTypes["default"].func,
  value: _propTypes["default"].array,
  maxSize: _propTypes["default"].number,
  data: _propTypes["default"].array,
  api: _propTypes["default"].func,
  // 异步加载时会用到
  showSearch: _propTypes["default"].bool,
  label: _propTypes["default"].string,
  showLabel: _propTypes["default"].bool
};
exports.propTypes = propTypes;
var defaultPropTypes = {
  prefixCls: 'mkui-fee-type-tags-select',
  onChange: _noop["default"],
  multiple: true,
  readonly: false,
  title: '',
  subTitle: '',
  value: [],
  data: [],
  maxSize: 10,
  api: _noop["default"],
  showSearch: false,
  label: '费用类型',
  showLabel: false
};
exports.defaultPropTypes = defaultPropTypes;
//# sourceMappingURL=PropTypes.js.map
