"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _classnames = _interopRequireDefault(require("classnames"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { return function () { var Super = _getPrototypeOf(Derived), result; if (_isNativeReflectConstruct()) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var CurrencyDisabledView = /*#__PURE__*/function (_React$Component) {
  _inherits(CurrencyDisabledView, _React$Component);

  var _super = _createSuper(CurrencyDisabledView);

  /** *******************static************************** */

  /** *******************life cycle************************** */
  function CurrencyDisabledView(props) {
    _classCallCheck(this, CurrencyDisabledView);

    return _super.call(this, props);
  }
  /** *******************render************************** */


  _createClass(CurrencyDisabledView, [{
    key: "formatCcyCode",
    value: function formatCcyCode(ccyCode) {
      return ccyCode === 'CNY' ? '￥' : ccyCode;
    }
  }, {
    key: "render",
    value: function render() {
      var _this$props$data = this.props.data,
          orgCcyCode = _this$props$data.orgCcyCode,
          orgAmount = _this$props$data.orgAmount,
          baseCcyCode = _this$props$data.baseCcyCode,
          baseAmount = _this$props$data.baseAmount;
      var _this$props$data$valu = this.props.data.value,
          orgAdjustedAmount = _this$props$data$valu.orgAdjustedAmount,
          baseAdjustedAmount = _this$props$data$valu.baseAdjustedAmount;
      var formatCcyCode = this.formatCcyCode,
          hasAdjusted = orgAmount - orgAdjustedAmount !== 0;
      return /*#__PURE__*/_react["default"].createElement("div", {
        className: "control-view-item"
      }, /*#__PURE__*/_react["default"].createElement("div", {
        className: "control"
      }, /*#__PURE__*/_react["default"].createElement("div", {
        className: "multiple-amount"
      }, /*#__PURE__*/_react["default"].createElement("span", null, /*#__PURE__*/_react["default"].createElement("strong", null, "\u6536\u6B3E\uFF1A", /*#__PURE__*/_react["default"].createElement("i", null, formatCcyCode(baseCcyCode))), baseAdjustedAmount), hasAdjusted && /*#__PURE__*/_react["default"].createElement("span", {
        className: "adjusted"
      }, /*#__PURE__*/_react["default"].createElement("i", null, formatCcyCode(baseCcyCode)), baseAmount)), /*#__PURE__*/_react["default"].createElement("div", {
        className: "multiple-amount"
      }, /*#__PURE__*/_react["default"].createElement("span", null, /*#__PURE__*/_react["default"].createElement("span", null, "\u6D88\u8D39\uFF1A", /*#__PURE__*/_react["default"].createElement("i", null, formatCcyCode(orgCcyCode))), orgAdjustedAmount), hasAdjusted && /*#__PURE__*/_react["default"].createElement("span", {
        className: "adjusted"
      }, /*#__PURE__*/_react["default"].createElement("i", null, formatCcyCode(orgCcyCode)), orgAmount))));
    }
  }]);

  return CurrencyDisabledView;
}(_react["default"].Component);

_defineProperty(CurrencyDisabledView, "propTypes", {
  data: _propTypes["default"].object
});

_defineProperty(CurrencyDisabledView, "defaultProps", {
  data: {}
});

var _default = CurrencyDisabledView;
exports["default"] = _default;
//# sourceMappingURL=CurrencyDisabledView.js.map
