function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { return function () { var Super = _getPrototypeOf(Derived), result; if (_isNativeReflectConstruct()) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

/**
 * Created by pzf on 19/9/1.
 *
 */

/* eslint func-names: 1 */
import React, { Fragment } from 'react';
import { TagsSelect, TransferModal } from 'mkui-ext';
import { defaultPropTypes, propTypes } from './PropTypes';

var FeeTypeTagsSelect = /*#__PURE__*/function (_React$Component) {
  _inherits(FeeTypeTagsSelect, _React$Component);

  var _super = _createSuper(FeeTypeTagsSelect);

  /** *******************static************************** */

  /** *******************life cycle************************** */
  function FeeTypeTagsSelect(props) {
    var _this;

    _classCallCheck(this, FeeTypeTagsSelect);

    _this = _super.call(this, props);
    _this.state = {
      value: props.value ? props.value : [],
      visible: false
    };
    return _this;
  }

  _createClass(FeeTypeTagsSelect, [{
    key: "clickHandle",
    value: function clickHandle() {
      this.setState({
        visible: true
      });
    }
  }, {
    key: "cancleHandle",
    value: function cancleHandle() {
      this.setState({
        visible: false
      });
    }
  }, {
    key: "okHandle",
    value: function okHandle(data) {
      this.setState({
        value: data,
        visible: false
      });
      this.fireChange(data);
    }
  }, {
    key: "fireChange",
    value: function fireChange(choosed) {
      var onChange = this.props.onChange;
      onChange(choosed);
    }
  }, {
    key: "render",
    value: function render() {
      var _this2 = this;

      var _this$props = this.props,
          multiple = _this$props.multiple,
          api = _this$props.api,
          placeholder = _this$props.placeholder,
          label = _this$props.label,
          showLabel = _this$props.showLabel;
      var _this$state = this.state,
          visible = _this$state.visible,
          value = _this$state.value;
      return /*#__PURE__*/React.createElement(Fragment, null, /*#__PURE__*/React.createElement(TagsSelect, {
        label: label,
        value: value,
        render: function render(item) {
          return item.feeTypeName;
        },
        keyName: "feeTypeCode",
        onClick: function onClick() {
          _this2.clickHandle();
        },
        placeholder: placeholder,
        showLabel: showLabel
      }), /*#__PURE__*/React.createElement(TransferModal, {
        title: "".concat(label, "\u9009\u62E9"),
        subTitle: "\u8D39\u7528\u7C7B\u578B",
        value: value,
        visible: visible,
        multiple: multiple,
        api: api,
        showSearch: false,
        keyName: "feeTypeCode",
        categoryKeyName: "categoryCode",
        render: function render(item) {
          return item.feeTypeName;
        },
        categoryRender: function categoryRender(item) {
          return item.categoryName;
        },
        onCancle: function onCancle() {
          _this2.cancleHandle();
        },
        onOk: function onOk(data) {
          _this2.okHandle(data);
        }
      }));
    }
  }]);

  return FeeTypeTagsSelect;
}(React.Component);

_defineProperty(FeeTypeTagsSelect, "propTypes", propTypes);

_defineProperty(FeeTypeTagsSelect, "defaultProps", defaultPropTypes);

export default FeeTypeTagsSelect;
//# sourceMappingURL=FeeTypeTagsSelect.js.map
