"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.camelCase = camelCase;
exports.lineSplit = lineSplit;
exports.isEmpty = isEmpty;

function camelCase(name) {
  return name.charAt(0).toUpperCase() + name.slice(1).replace(/-(\w)/g, function (m, n) {
    return n.toUpperCase();
  });
}

function lineSplit(name) {
  return name.replace(/[A-Z]/g, function (m, n) {
    return '-' + m.toLowerCase();
  });
}

function isEmpty(value) {
  return typeof value === 'undefined' || value === null || value === '';
}
//# sourceMappingURL=stringUtils.js.map
