"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.getDataSource = getDataSource;
exports.getIconName = getIconName;

var _lang = _interopRequireDefault(require("lodash/lang"));

var _clone = require("../_util/clone");

var _iconMapping = _interopRequireDefault(require("./iconMapping"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

/**
 * Created by pzf on 18/9/1.
 *
 */

/** *******************Select************************** */

/**
 * 把外面传进来的数据解除引用关联
 * @param dataSource
 * @returns {T[]}
 */
function getDataSource(props) {
  return (0, _clone.deepClone)(props.data);
}

function getIconName(iconCode) {
  return _iconMapping["default"][iconCode] ? "fee-".concat(_iconMapping["default"][iconCode]) : "fee-".concat(iconCode);
}
//# sourceMappingURL=util.js.map
