"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.NO_INVOICE_IMG = exports.DETAIL_MAPPER = exports.PAGE_SIZE = exports.TRANSFORM = void 0;
var TRANSFORM = {
  /* 图片初始状态 */
  INIT_STATE: {
    rotate: 0,
    scale: 1,
    left: 0,
    top: 0
  },

  /* 图片缩放倍率 */
  SCALE_RATE: 1.2,
  MAX_SCALE_RATE: Math.pow(1.2, 3),
  MIN_SCALE_RATE: 1 / Math.pow(1.2, 3),

  /* 图片旋转度数 */
  ROTATE_DEG: 90
};
exports.TRANSFORM = TRANSFORM;
var PAGE_SIZE = 5;
exports.PAGE_SIZE = PAGE_SIZE;
var DETAIL_MAPPER = {
  invoiceCode: '发票代码',
  invoiceNumber: '发票号码',
  issueDate: '开票日期',
  checksum: '校验码',
  totalPriceAmount: '税前金额',
  totalPriceAndTax: '价税合计',
  totalTaxAmount: '税额',
  buyerName: '名称',
  buyerTaxNumber: '税号'
};
exports.DETAIL_MAPPER = DETAIL_MAPPER;
var NO_INVOICE_IMG = 'https://cmimg.maycur.com/front-static-resource/imgs/noInvoice.png';
exports.NO_INVOICE_IMG = NO_INVOICE_IMG;
//# sourceMappingURL=constant.js.map
